/**
 * Copyright (C) 2014-2015 Justin James.
 *
 * This license must be preserved.
 * Any applications, libraries, or code which make any use of any
 * component of this program must not be commercial, unless explicit
 * permission is granted from the original author. The use of this
 * program for non-profit purposes is permitted.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * In the event that this license restricts you from making desired use of this program, contact the original author.
 * Written by Justin James <justin.aj@hotmail.com>
 */

class eX_Rcon extends Rx_Rcon;

function eXLog(string text)
{
	local Rx_RconConnection con;
	foreach Subscribers(con)
		con.SendText("x" $ text);
}

function bool Subscribe(Rx_RconConnection connection)
{
	if (Super.Subscribe(connection))
	{
		// "version" | "1" | Connection Name | Server Name | Elapsed Time | Time Limit
		connection.SendText("xversion" $ Chr(160) $ "1" $ Chr(160) $ connection.IPstring $ Chr(160) $ WorldInfo.GRI.ServerName $ Chr(160) $ WorldInfo.GetMapName() $ Chr(160) $ WorldInfo.GRI.ElapsedTime $ Chr(160) $ WorldInfo.GRI.TimeLimit);
		return true;
	}
	return false;
}

DefaultProperties
{
	AcceptClass=class'eXtendedRCON.eX_RconConnection'
}