/**
 * Copyright (C) 2014-2015 Justin James.
 *
 * This license must be preserved.
 * Any applications, libraries, or code which make any use of any
 * component of this program must not be commercial, unless explicit
 * permission is granted from the original author. The use of this
 * program for non-profit purposes is permitted.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 *
 * In the event that this license restricts you from making desired use of this program, contact the original author.
 * Written by Justin James <justin.aj@hotmail.com>
 */

class eXtendedRCON extends UTMutator;

function xLog(string text)
{
	if (Rx_Game(WorldInfo.Game).Rcon != None)
	{
		if (eX_Rcon(Rx_Game(WorldInfo.Game).Rcon) == None)
			ReplaceWith(Rx_Game(WorldInfo.Game).Rcon, "eXtendedRCON.eX_Rcon");
		eX_Rcon(Rx_Game(WorldInfo.Game).Rcon).eXLog(text);
	}
	else
		Rx_Game(WorldInfo.Game).RxLog("ERROR: RCON not found!");
}

function InitMutator(string Options, out string ErrorMessage)
{
	if (Rx_Game(WorldInfo.Game).Rcon == None)
		Rx_Game(WorldInfo.Game).Rcon = Spawn(class'eX_Rcon');
	else
		Rx_Game(WorldInfo.Game).RxLog("Wow rcon spawns fast!");
	Super.InitMutator(Options, ErrorMessage);
}

function bool CheckReplacement(Actor Other)
{
	if (Rx_Vehicle(Other) != None)
	{
		if (Rx_Game(WorldInfo.Game).VehicleManager != None && Rx_Game(WorldInfo.Game).VehicleManager.NOD_ProductionPlace.L == Other.location)
		{
			if (Rx_Game(WorldInfo.Game).VehicleManager.NOD_Queue[0].Buyer != None)
				xLog("spawn_vehicle" $ Chr(160) $ "Buy" $ Chr(160) $ Other.class.name $ Chr(160) $ class'Rx_PRI'.static.LogNameOf(Rx_Game(WorldInfo.Game).VehicleManager.NOD_Queue[0].Buyer));
			else
				xLog("spawn_vehicle" $ Chr(160) $ "Nod" $ Chr(160) $ Other.class.name);
		}
		else if (Rx_Game(WorldInfo.Game).VehicleManager != None && Rx_Game(WorldInfo.Game).VehicleManager.GDI_ProductionPlace.L == Other.location)
		{
			if (Rx_Game(WorldInfo.Game).VehicleManager.GDI_Queue[0].Buyer != None)
				xLog("spawn_vehicle" $ Chr(160) $ "Buy" $ Chr(160) $ Other.class.name $ Chr(160) $ class'Rx_PRI'.static.LogNameOf(Rx_Game(WorldInfo.Game).VehicleManager.GDI_Queue[0].Buyer));
			else
				xLog("spawn_vehicle" $ Chr(160) $ "GDI" $ Chr(160) $ Other.class.name);
		}
		else
			xLog("spawn_vehicle" $ Chr(160) $ "Neutral" $ Chr(160) $ Other.class.name);
	}
	else if (Rx_Weapon(Other) != None)
		xLog("grant_weapon" $ Chr(160) $ class'Rx_PRI'.static.LogNameOf(Other.Instigator.PlayerReplicationInfo) $ Chr(160) $ Other.class.name);
	else if (Rx_InventoryManager(Other) != None)
		xLog("grant_character" $ Chr(160) $ class'Rx_PRI'.static.LogNameOf(Other.Instigator.PlayerReplicationInfo) $ Chr(160) $ Other.class.name);
	else if (Rx_Weapon_DeployedC4(Other) != None)
		xLog("mine_place" $ Chr(160) $ class'Rx_PRI'.static.LogNameOf(Other.Instigator.PlayerReplicationInfo) $ Chr(160) $ Other.class.name);
	else if (Rx_Rcon(Other) != None && !Other.IsA('eX_Rcon'))
	{
		//ReplaceWith(Other, "eXtendedRCON.eX_Rcon");
		//Other = Spawn(class'eX_Rcon');
		//Rx_Game(WorldInfo.Game).Rcon = eX_Rcon(Other);
		return true;
	}
	/*else if (Rx_Bot(Other) != None)
		xLog("bot_join" $ Chr(160) $ class'Rx_PRI'.static.LogNameOf(Rx_Bot(Other).PlayerReplicationInfo) $ Chr(160) $ Other.class.name);
	else if (PlayerReplicationInfo(Other) != None)
		xLog("create_pri" $ Chr(160) $ class'Rx_PRI'.static.LogNameOf(PlayerReplicationInfo(Other)) $ Chr(160) $ Other.class.name);
	else // Spammy
		xLog("create" $ Chr(160) $ class'Rx_PRI'.static.LogNameOf(Other.Instigator.PlayerReplicationInfo) $ Chr(160) $ Other.class.name);*/

	if (Rx_Weapon_DeployedC4(Other) != None && Rx_Weapon_DeployedC4(Other).bUsesMineLimit)
		xLog("mlimit_inc" $ Chr(160) $ class'Rx_PRI'.static.LogNameOf(Other.Instigator.PlayerReplicationInfo) $ Chr(160) $ Other.class.name $ Chr(160) $ (Rx_TeamInfo(Rx_Game(WorldInfo.Game).Teams[Other.Instigator.GetTeamNum()]).mineCount + 1) $ Chr(160) $ Rx_Game(WorldInfo.Game).MineLimit);

	return Super.CheckReplacement(Other);
}

/*
	Structure: "kill" | <Damage Type> | <Killer Type> [Killer Data] | <Killed Type> [Killed Data]
	Types:
		1 = Player
		2 = Non-Player
		3 = None
*/

function bool PreventDeath(Pawn Killed, Controller Killer, class<DamageType> damageType, Object.Vector HitLocation)
{
	local Rx_Defence turret;

	if (Killer != None)
	{
		if (Killer.PlayerReplicationInfo.PlayerID == 0) // AI Non-Player Killer
		{
			if (Rx_SentinelController(Killer) != None) // Primary defense structure killer
			{
				if (Killed.PlayerReplicationInfo.PlayerID == 0 && Rx_VehicleSeatPawn(Killed) == None) // killed non-player.
					xLog("kill" $ Chr(160) $ damageType.name $ Chr(160) $ Chr(2) $ class'Rx_Game'.static.GetTeamName(Rx_SentinelController(Killer).Cannon.GetTeamNum()) $ "," $ Rx_SentinelController(Killer).Cannon.class.name $ Chr(160) $ Chr(2) $ class'Rx_Game'.static.GetTeamName(Killed.GetTeamNum()) $ "," $ Killed.class.name);
				else // killed player
					xLog("kill" $ Chr(160) $ damageType.name $ Chr(160) $ Chr(2) $ class'Rx_Game'.static.GetTeamName(Rx_SentinelController(Killer).Cannon.GetTeamNum()) $ "," $ Rx_SentinelController(Killer).Cannon.class.name $ Chr(160) $ Chr(1) $ UTPawn(Killed).CurrCharClassInfo.name $ "," $ class'Rx_PRI'.static.LogNameOf(Killed.PlayerReplicationInfo));
			}
			else
			{
				foreach Killer.OverlappingActors(class'Rx_Defence', turret, 0.0f)
				{
					if (Killed.PlayerReplicationInfo.PlayerID == 0 && Rx_VehicleSeatPawn(Killed) == None) // Non-Player killed non-player.
						xLog("kill" $ Chr(160) $ damageType.name $ Chr(160) $ Chr(2) $ class'Rx_Game'.static.GetTeamName(turret.GetTeamNum()) $ "," $ turret.class.name $ Chr(160) $ Chr(2) $ class'Rx_Game'.static.GetTeamName(Killed.GetTeamNum()) $ "," $ Killed.class.name);
					else // Non-Player killed player.
						xLog("kill" $ Chr(160) $ damageType.name $ Chr(160) $ Chr(2) $ class'Rx_Game'.static.GetTeamName(turret.GetTeamNum()) $ "," $ turret.class.name $ Chr(160) $ Chr(1) $ UTPawn(Killed).CurrCharClassInfo.name $ "," $ class'Rx_PRI'.static.LogNameOf(Killed.PlayerReplicationInfo));
					return Super.PreventDeath(Killed, Killer, damageType, HitLocation);
				}
				if (Killed.PlayerReplicationInfo.PlayerID == 0 && Rx_VehicleSeatPawn(Killed) == None) // Non-Player killed non-player.
					xLog("kill" $ Chr(160) $ damageType.name $ Chr(160) $ Chr(2) $ class'Rx_Game'.static.GetTeamName(Killer.GetTeamNum()) $ "," $ Killer.class.name $ Chr(160) $ Chr(2) $ class'Rx_Game'.static.GetTeamName(Killed.GetTeamNum()) $ "," $ Killed.class.name);
				else // Non-Player killed player.
					xLog("kill" $ Chr(160) $ damageType.name $ Chr(160) $ Chr(2) $ class'Rx_Game'.static.GetTeamName(Killer.GetTeamNum()) $ "," $ Killer.class.name $ Chr(160) $ Chr(1) $ UTPawn(Killed).CurrCharClassInfo.name $ "," $ class'Rx_PRI'.static.LogNameOf(Killed.PlayerReplicationInfo));
			}
		}
		else if (Killed.PlayerReplicationInfo.PlayerID == 0 && Rx_VehicleSeatPawn(Killed) == None) // Player killed non-player.
			xLog("kill" $ Chr(160) $ damageType.name $ Chr(160) $ Chr(1) $ UTPlayerReplicationInfo(Killer.PlayerReplicationInfo).CharClassInfo.name $ "," $ class'Rx_PRI'.static.LogNameOf(Killer.PlayerReplicationInfo) $ Chr(160) $ Chr(2) $ class'Rx_Game'.static.GetTeamName(Killed.GetTeamNum()) $ "," $ Killed.class.name);
		else // Player killed player
			xLog("kill" $ Chr(160) $ damageType.name $ Chr(160) $ Chr(1) $ UTPlayerReplicationInfo(Killer.PlayerReplicationInfo).CharClassInfo.name $ "," $ class'Rx_PRI'.static.LogNameOf(Killer.PlayerReplicationInfo) $ Chr(160) $ Chr(1) $ UTPawn(Killed).CurrCharClassInfo.name $ "," $ class'Rx_PRI'.static.LogNameOf(Killed.PlayerReplicationInfo));
	}
	else if (Killed.PlayerReplicationInfo.PlayerID == 0 && Rx_VehicleSeatPawn(Killed) == None) // Nothing killed AI Non-Player
		xLog("kill" $ Chr(160) $ damageType.name $ Chr(160) $ Chr(3) $ Chr(160) $ Chr(2) $ class'Rx_Game'.static.GetTeamName(Killed.GetTeamNum()) $ "," $ Killed.class.name);
	else // Nothing killed player
		xLog("kill" $ Chr(160) $ damageType.name $ Chr(160) $ Chr(3) $ Chr(160) $ Chr(1) $ UTPawn(Killed).CurrCharClassInfo.name $ "," $ class'Rx_PRI'.static.LogNameOf(Killed.PlayerReplicationInfo));

	return Super.PreventDeath(Killed, Killer, damageType, HitLocation);
}